/*
*	1. The mechanism of "cmp" function and the "void*" type involved there.
*	2. The choice min-heap or max-heap can be determined by changing the function of "cmp".
*	3. The heap array's subscript starts from zero.
*	4. The concept of "heap array" and "object array", which work collaborarily.
*/


#ifndef B_HEAP_H
#define	B_HEAP_H

#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <string.h>


#define		B_CONFIG_FILE		"b_config.txt"
#define		MAX_FILENAME_LENG	256
#define		FLOAT				float

/*
#define		B_INPUT_FILE	"b_input.txt"
#define		B_OUTPUT_FILE	"b_output.txt"
*/

//The structure of the object that indexed by the binary heap.
typedef	struct h_obj
{
	int		id;
	int		valid_tag;
/*
	int		tag;
	int		prev;
*/
	int		loc;				

	FLOAT	gain;				//object-specific.
} h_obj_t;


//The structure of the node of a heap.
typedef	struct b_heap
{
	int			size;			//the heap's size.
	int			rear;			//the heap's rear tag.
	h_obj_t*	obj_arr;		//the object array.
	int*		h_arr;			//the heap array.
} b_heap_t;



//-------------------------------------

//int cmp( const void* obj_v, int fir, int sec);

int cmp_min( int* array, int n1, int n2, h_obj_t* obj_v);

int cmp_max( int* array, int n1, int n2, h_obj_t* obj_v);

//-------------------------------------

void b_t_heapify( int* array, int cur, h_obj_t* obj_v);

void t_b_heapify( int* array, int cur, int rear, h_obj_t* obj_v);

int insert_b_heap( b_heap_t* b_h, int n);

int get_top( b_heap_t* b_h);

void update_key( b_heap_t* b_h, int k);

//-------------------------------------


void print_b_heap( FILE* o_fp, b_heap_t* b_h);

void test_b_heap( );


#endif