

#ifndef DATA_UTILITY_H
#define DATA_UTILITY_H

#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include "data_structure.h"
//#include "Viral_Marketing.h"

#define	MAX_FILENAME_LENG		256
#define	MAX_DESCRIPTION_LENG	100
#define	ENHANCE_RAND_TIMES		1000

#define CONFIG_FILE				"config.txt"
#define POWER_LAW_CONFIG		"power_law_graph_config.txt"
#define	REMOVE_MUL_EDGES_CONFIG	"remove_multiple_edges_config.txt"
#define	SAMPLE_GRAPH_CONFIG		"sample_graph_config.txt"


typedef struct config
{
	char	g_file[MAX_FILENAME_LENG];
	int		node_n;
	int		edge_n;
	
	int		sample_n;
	int		J;
	double	ratio;
	int		alg;
	int		model;
} config_t;



float rand_f( float min_v, float max_v);

int rand_i( int min_v, int max_v);

//long enhance_rand_i( long min_v, long max_v);	

void release_graph_copy( graph_t* graph_v);

/*-----------------------------------------------------------*/

config_t* read_config( );

void power_law_preprocess( );

void remove_multiple_edges( );

void sample_graph( );

#endif